# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class MicrosoftPartnerSdkContractsAnalyticsCustomerLicensesUsageInsights(Model):
    """Contains customer level insights about license usage.

    Variables are only populated by the server, and will be ignored when
    sending a request.

    :param customer_id: The customer identifier.
    :type customer_id: str
    :param customer_name: The customer name.
    :type customer_name: str
    :param workload_code: The workload code.
    :type workload_code: str
    :param product_name: The product name.
     TODO : figure out locale for the names. Identify if they can come from
     catalog
    :type product_name: str
    :param licenses_active: The number of active licenses.
    :type licenses_active: long
    :param licenses_qualified: The number of qualified licenses.
    :type licenses_qualified: long
    :param usage_percent: The adjusted percentage of licenses used.
    :type usage_percent: float
    :param workload_name: The workload name. (Examples : sharepoint, exchange)
    :type workload_name: str
    :param processed_date_time: The date and time when the data was
     aggregated.
    :type processed_date_time: datetime
    :param service_code: The service code of the license.
    :type service_code: str
    :param service_name: The service name. (Example : Office, CRM)
    :type service_name: str
    :param channel: The channel name of the service. (Example : reseller)
    :type channel: str
    :ivar attributes: Gets the attributes.
    :vartype attributes:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1CommonResourceAttributes
    """

    _validation = {
        'attributes': {'readonly': True},
    }

    _attribute_map = {
        'customer_id': {'key': 'customerId', 'type': 'str'},
        'customer_name': {'key': 'customerName', 'type': 'str'},
        'workload_code': {'key': 'workloadCode', 'type': 'str'},
        'product_name': {'key': 'productName', 'type': 'str'},
        'licenses_active': {'key': 'licensesActive', 'type': 'long'},
        'licenses_qualified': {'key': 'licensesQualified', 'type': 'long'},
        'usage_percent': {'key': 'usagePercent', 'type': 'float'},
        'workload_name': {'key': 'workloadName', 'type': 'str'},
        'processed_date_time': {'key': 'processedDateTime', 'type': 'iso-8601'},
        'service_code': {'key': 'serviceCode', 'type': 'str'},
        'service_name': {'key': 'serviceName', 'type': 'str'},
        'channel': {'key': 'channel', 'type': 'str'},
        'attributes': {'key': 'attributes', 'type': 'MicrosoftPartnerSdkContractsV1CommonResourceAttributes'},
    }

    def __init__(self, customer_id=None, customer_name=None, workload_code=None, product_name=None, licenses_active=None, licenses_qualified=None, usage_percent=None, workload_name=None, processed_date_time=None, service_code=None, service_name=None, channel=None):
        super(MicrosoftPartnerSdkContractsAnalyticsCustomerLicensesUsageInsights, self).__init__()
        self.customer_id = customer_id
        self.customer_name = customer_name
        self.workload_code = workload_code
        self.product_name = product_name
        self.licenses_active = licenses_active
        self.licenses_qualified = licenses_qualified
        self.usage_percent = usage_percent
        self.workload_name = workload_name
        self.processed_date_time = processed_date_time
        self.service_code = service_code
        self.service_name = service_name
        self.channel = channel
        self.attributes = None
