# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class MicrosoftPartnerSdkContractsV1Offer(Model):
    """Describes a product listed in the reseller catalog that is available to
    customers.

    Variables are only populated by the server, and will be ignored when
    sending a request.

    :param id: Gets or sets the offer identifier.
    :type id: str
    :param provider_id: Gets or sets the offer provider identifier.
    :type provider_id: str
    :param provider_name: Gets or sets the offer provider name.
    :type provider_name: str
    :param provider_location_id: Gets or sets the offer provider location
     identifier.
    :type provider_location_id: str
    :param name: Gets or sets the offer name.
    :type name: str
    :param description: Gets or sets a description of the offer.
    :type description: str
    :param minimum_quantity: Gets or sets the minimum quantity available.
    :type minimum_quantity: int
    :param maximum_quantity: Gets or sets the maximum quantity available.
    :type maximum_quantity: int
    :param rank: Gets or sets the offer rank or priority compared to other
     categories in the same product line.
     This property should be set only if there is more than one offer for a
     given product line.
    :type rank: int
    :param uri: Gets or sets the offer URI.
    :type uri: str
    :param locale: Gets or sets the locale in which the offer applies.
    :type locale: str
    :param country: Gets or sets the country/region where the offer applies.
    :type country: str
    :param category: Gets or sets the category.
    :type category:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1OfferCategory
    :param limit_unit_of_measure: Gets or sets value for Limit unit of measure
     Ex: Concurrent, LifeTime, None
    :type limit_unit_of_measure: str
    :param limit: Gets or sets value for Limit
    :type limit: int
    :param term_unit_of_measure: Gets or sets value for Term unit of measure
    :type term_unit_of_measure: str
    :param term: Gets or sets value for Term
    :type term: int
    :param prerequisite_offers: Gets or sets the prerequisite offers.
    :type prerequisite_offers: list[str]
    :param is_add_on: Gets or sets a value indicating whether this instance is
     an addon.
    :type is_add_on: bool
    :param has_add_ons: Gets or sets a value indicating whether this instance
     has addons.
    :type has_add_ons: bool
    :param is_available_for_purchase: Gets or sets a value indicating whether
     this instance is available for purchase.
    :type is_available_for_purchase: bool
    :param billing: Gets or sets the billing type for the line item purchase.
     (Examples : "none", "usage", or "license".). Possible values include:
     'none', 'usage', 'license'
    :type billing: str or ~microsoft.store.partnercenterservices.models.enum
    :param supported_billing_cycles: Gets or sets the billing cycles supported
     for this offer.
    :type supported_billing_cycles: list[str]
    :param is_auto_renewable: Gets or sets a value indicating whether the
     offer renews automatically.
    :type is_auto_renewable: bool
    :param is_internal: Gets or sets a value indicating whether the offer is
     internal only.
    :type is_internal: bool
    :param is_microsoft_product: Gets or sets a value indicating whether the
     offer is a microsoft product only.
    :type is_microsoft_product: bool
    :param upgrade_target_offers: Gets or sets the list of offers that this
     offer can be upgraded to.
    :type upgrade_target_offers: list[str]
    :param conversion_target_offers: Gets or sets the list of offers that this
     offer can be converted to.
    :type conversion_target_offers: list[str]
    :param resellee_qualifications: Gets or sets the list of resellee
     qualifications on a given offer.
     Both the partner and customer should satisfy at least one of these
     qualifications to get the specific offer.
     If no qualifications are specified, then the offer is available to all
     partners/customers.
    :type resellee_qualifications: list[str]
    :param reseller_qualifications: Gets or sets the list of reseller
     qualifications on a given offer.
     The partner should satisfy at least one of these qualifications to get the
     specific offer.
     If no qualifications are specified, then offers are available to all
     partners.
    :type reseller_qualifications: list[str]
    :param sales_group_id: Gets or sets the sales group identifier for the
     offer.
     When placing an order, ensure that the order contains items of the sales
     group, if not split them.
    :type sales_group_id: str
    :param is_trial: Gets or sets a value indicating whether the offer is a
     trial offer.
    :type is_trial: bool
    :param acquisition_type: Gets or sets the acquisition type for the offer.
     If the acquisition type is purchase, then acquiring this offer is through
     an order.
     If the acquisition type is referral, then acquiring this offer is through
     a referral. Possible values include: 'purchase', 'referral'
    :type acquisition_type: str or
     ~microsoft.store.partnercenterservices.models.enum
    :param supported_catalog_types: Gets or sets the supported catalog types.
    :type supported_catalog_types: list[str]
    :param actions: Gets or sets the actions.
    :type actions: list[str]
    :param product: Gets or sets the product.
    :type product:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1OfferProduct
    :param unit_type: Gets or sets the type of the unit.
    :type unit_type: str
    :param links: Gets or sets the offer's "learn more" link.
    :type links:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1ContractsLinksOfferLinks
    :ivar attributes: Gets the attributes.
    :vartype attributes:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1CommonResourceAttributes
    """

    _validation = {
        'attributes': {'readonly': True},
    }

    _attribute_map = {
        'id': {'key': 'id', 'type': 'str'},
        'provider_id': {'key': 'providerId', 'type': 'str'},
        'provider_name': {'key': 'providerName', 'type': 'str'},
        'provider_location_id': {'key': 'providerLocationId', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'minimum_quantity': {'key': 'minimumQuantity', 'type': 'int'},
        'maximum_quantity': {'key': 'maximumQuantity', 'type': 'int'},
        'rank': {'key': 'rank', 'type': 'int'},
        'uri': {'key': 'uri', 'type': 'str'},
        'locale': {'key': 'locale', 'type': 'str'},
        'country': {'key': 'country', 'type': 'str'},
        'category': {'key': 'category', 'type': 'MicrosoftPartnerSdkContractsV1OfferCategory'},
        'limit_unit_of_measure': {'key': 'limitUnitOfMeasure', 'type': 'str'},
        'limit': {'key': 'limit', 'type': 'int'},
        'term_unit_of_measure': {'key': 'termUnitOfMeasure', 'type': 'str'},
        'term': {'key': 'term', 'type': 'int'},
        'prerequisite_offers': {'key': 'prerequisiteOffers', 'type': '[str]'},
        'is_add_on': {'key': 'isAddOn', 'type': 'bool'},
        'has_add_ons': {'key': 'hasAddOns', 'type': 'bool'},
        'is_available_for_purchase': {'key': 'isAvailableForPurchase', 'type': 'bool'},
        'billing': {'key': 'billing', 'type': 'str'},
        'supported_billing_cycles': {'key': 'supportedBillingCycles', 'type': '[str]'},
        'is_auto_renewable': {'key': 'isAutoRenewable', 'type': 'bool'},
        'is_internal': {'key': 'isInternal', 'type': 'bool'},
        'is_microsoft_product': {'key': 'isMicrosoftProduct', 'type': 'bool'},
        'upgrade_target_offers': {'key': 'upgradeTargetOffers', 'type': '[str]'},
        'conversion_target_offers': {'key': 'conversionTargetOffers', 'type': '[str]'},
        'resellee_qualifications': {'key': 'reselleeQualifications', 'type': '[str]'},
        'reseller_qualifications': {'key': 'resellerQualifications', 'type': '[str]'},
        'sales_group_id': {'key': 'salesGroupId', 'type': 'str'},
        'is_trial': {'key': 'isTrial', 'type': 'bool'},
        'acquisition_type': {'key': 'acquisitionType', 'type': 'str'},
        'supported_catalog_types': {'key': 'supportedCatalogTypes', 'type': '[str]'},
        'actions': {'key': 'actions', 'type': '[str]'},
        'product': {'key': 'product', 'type': 'MicrosoftPartnerSdkContractsV1OfferProduct'},
        'unit_type': {'key': 'unitType', 'type': 'str'},
        'links': {'key': 'links', 'type': 'MicrosoftPartnerSdkContractsV1ContractsLinksOfferLinks'},
        'attributes': {'key': 'attributes', 'type': 'MicrosoftPartnerSdkContractsV1CommonResourceAttributes'},
    }

    def __init__(self, id=None, provider_id=None, provider_name=None, provider_location_id=None, name=None, description=None, minimum_quantity=None, maximum_quantity=None, rank=None, uri=None, locale=None, country=None, category=None, limit_unit_of_measure=None, limit=None, term_unit_of_measure=None, term=None, prerequisite_offers=None, is_add_on=None, has_add_ons=None, is_available_for_purchase=None, billing=None, supported_billing_cycles=None, is_auto_renewable=None, is_internal=None, is_microsoft_product=None, upgrade_target_offers=None, conversion_target_offers=None, resellee_qualifications=None, reseller_qualifications=None, sales_group_id=None, is_trial=None, acquisition_type=None, supported_catalog_types=None, actions=None, product=None, unit_type=None, links=None):
        super(MicrosoftPartnerSdkContractsV1Offer, self).__init__()
        self.id = id
        self.provider_id = provider_id
        self.provider_name = provider_name
        self.provider_location_id = provider_location_id
        self.name = name
        self.description = description
        self.minimum_quantity = minimum_quantity
        self.maximum_quantity = maximum_quantity
        self.rank = rank
        self.uri = uri
        self.locale = locale
        self.country = country
        self.category = category
        self.limit_unit_of_measure = limit_unit_of_measure
        self.limit = limit
        self.term_unit_of_measure = term_unit_of_measure
        self.term = term
        self.prerequisite_offers = prerequisite_offers
        self.is_add_on = is_add_on
        self.has_add_ons = has_add_ons
        self.is_available_for_purchase = is_available_for_purchase
        self.billing = billing
        self.supported_billing_cycles = supported_billing_cycles
        self.is_auto_renewable = is_auto_renewable
        self.is_internal = is_internal
        self.is_microsoft_product = is_microsoft_product
        self.upgrade_target_offers = upgrade_target_offers
        self.conversion_target_offers = conversion_target_offers
        self.resellee_qualifications = resellee_qualifications
        self.reseller_qualifications = reseller_qualifications
        self.sales_group_id = sales_group_id
        self.is_trial = is_trial
        self.acquisition_type = acquisition_type
        self.supported_catalog_types = supported_catalog_types
        self.actions = actions
        self.product = product
        self.unit_type = unit_type
        self.links = links
        self.attributes = None
