# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class MicrosoftPartnerSdkContractsV1OrderLineItem(Model):
    """Represents order information for one specific offer of a product.
    An order contains an itemized list of offers, and each item is represented
    as an order line item.

    :param line_item_number: Gets or sets the line item number.
     Each line item in the collection has a unique line item number, ranging
     from 0 to count-1.
    :type line_item_number: int
    :param offer_id: Gets or sets the offer identifier.
    :type offer_id: str
    :param subscription_id: Gets or sets the identifier of the resulting
     subscription.
    :type subscription_id: str
    :param parent_subscription_id: Gets or sets the identifier of the parent
     subscription for an add-on offer.
     This parameter should only be set for an add-on offer purchase. It applies
     to
     an Order PATCH operation only.
    :type parent_subscription_id: str
    :param provisioning_context: Gets or sets the provisioning context.
    :type provisioning_context: dict[str, str]
    :param friendly_name: Gets or sets the friendly name for the subscription
     defined by the partner.
     This is an optional parameter used to disambiguate subscriptions.
    :type friendly_name: str
    :param quantity: Gets or sets the number of licenses for a licence-based
     subscription.
    :type quantity: int
    :param partner_id_on_record: Gets or sets the partner identifier on
     record.
     When an indirect provider places an order on behalf of an indirect
     reseller, populate this field
     with the MPN ID of the indirect reseller only (never the ID of the
     indirect provider).
     This ensures proper accounting for incentives.
    :type partner_id_on_record: str
    :param links: Gets the order's resulting contract information.
     This is an out parameter only, any input values to it will be ignored.
     Example: Contract: { contract_type:Subscription, contract_id:
     06bfd4f8-742d-41c6-9042-bb95ae5b4a05 }
    :type links:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1LinksOrderLineItemLinks
    """

    _attribute_map = {
        'line_item_number': {'key': 'lineItemNumber', 'type': 'int'},
        'offer_id': {'key': 'offerId', 'type': 'str'},
        'subscription_id': {'key': 'subscriptionId', 'type': 'str'},
        'parent_subscription_id': {'key': 'parentSubscriptionId', 'type': 'str'},
        'provisioning_context': {'key': 'provisioningContext', 'type': '{str}'},
        'friendly_name': {'key': 'friendlyName', 'type': 'str'},
        'quantity': {'key': 'quantity', 'type': 'int'},
        'partner_id_on_record': {'key': 'partnerIdOnRecord', 'type': 'str'},
        'links': {'key': 'links', 'type': 'MicrosoftPartnerSdkContractsV1LinksOrderLineItemLinks'},
    }

    def __init__(self, line_item_number=None, offer_id=None, subscription_id=None, parent_subscription_id=None, provisioning_context=None, friendly_name=None, quantity=None, partner_id_on_record=None, links=None):
        super(MicrosoftPartnerSdkContractsV1OrderLineItem, self).__init__()
        self.line_item_number = line_item_number
        self.offer_id = offer_id
        self.subscription_id = subscription_id
        self.parent_subscription_id = parent_subscription_id
        self.provisioning_context = provisioning_context
        self.friendly_name = friendly_name
        self.quantity = quantity
        self.partner_id_on_record = partner_id_on_record
        self.links = links
