# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class MicrosoftPartnerSdkContractsV1OrganizationProfile(Model):
    """Describes a partner's organization profile.

    Variables are only populated by the server, and will be ignored when
    sending a request.

    :param id: Gets or sets the organization's identifier.
    :type id: str
    :param company_name: GEts or sets the name of the company or organization.
    :type company_name: str
    :param default_address: Gets or sets the default address of the company or
     organization.
    :type default_address:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1Address
    :param tenant_id: Gets or sets the tenant identifier.
    :type tenant_id: str
    :param domain: Gets or sets the company or organization's domain.
    :type domain: str
    :param email: Gets or sets the company or organization's email
    :type email: str
    :param language: Gets or sets the preferred language for communication.
    :type language: str
    :param culture: Gets or sets the preferred culture for communication and
     currency, such as "en-us".
    :type culture: str
    :ivar profile_type: Gets the partner profile type. Possible values
     include: 'mpn_profile', 'billing_profile', 'support_profile',
     'legal_business_profile', 'organization_profile'
    :vartype profile_type: str or
     ~microsoft.store.partnercenterservices.models.enum
    :param links: Gets or sets the links.
    :type links:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1CommonResourceLinks
    :ivar attributes: Gets the attributes.
    :vartype attributes:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1CommonResourceAttributes
    """

    _validation = {
        'profile_type': {'readonly': True},
        'attributes': {'readonly': True},
    }

    _attribute_map = {
        'id': {'key': 'id', 'type': 'str'},
        'company_name': {'key': 'companyName', 'type': 'str'},
        'default_address': {'key': 'defaultAddress', 'type': 'MicrosoftPartnerSdkContractsV1Address'},
        'tenant_id': {'key': 'tenantId', 'type': 'str'},
        'domain': {'key': 'domain', 'type': 'str'},
        'email': {'key': 'email', 'type': 'str'},
        'language': {'key': 'language', 'type': 'str'},
        'culture': {'key': 'culture', 'type': 'str'},
        'profile_type': {'key': 'profileType', 'type': 'str'},
        'links': {'key': 'links', 'type': 'MicrosoftPartnerSdkContractsV1CommonResourceLinks'},
        'attributes': {'key': 'attributes', 'type': 'MicrosoftPartnerSdkContractsV1CommonResourceAttributes'},
    }

    def __init__(self, id=None, company_name=None, default_address=None, tenant_id=None, domain=None, email=None, language=None, culture=None, links=None):
        super(MicrosoftPartnerSdkContractsV1OrganizationProfile, self).__init__()
        self.id = id
        self.company_name = company_name
        self.default_address = default_address
        self.tenant_id = tenant_id
        self.domain = domain
        self.email = email
        self.language = language
        self.culture = culture
        self.profile_type = None
        self.links = links
        self.attributes = None
