# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class MicrosoftPartnerSdkContractsV1ServiceRequest(Model):
    """Describes a service request filed by a partner, including how that request
    is progressing.

    Variables are only populated by the server, and will be ignored when
    sending a request.

    :param title: Gets or sets the service request title.
    :type title: str
    :param description: Gets or sets the description.
    :type description: str
    :param severity: Gets or sets the severity. Possible values include:
     'unknown', 'critical', 'moderate', 'minimal'
    :type severity: str or ~microsoft.store.partnercenterservices.models.enum
    :param support_topic_id: Gets or sets the ID of the support topic.
    :type support_topic_id: str
    :param support_topic_name: Gets or sets the name of the support topic.
    :type support_topic_name: str
    :param id: Gets or sets the ID of the service request.
    :type id: str
    :param status: Gets or sets the status of the service request. Possible
     values include: 'none', 'open', 'closed', 'attention_needed'
    :type status: str or ~microsoft.store.partnercenterservices.models.enum
    :param organization: Gets or sets the organization for which the service
     request is created.
    :type organization:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1ServiceRequestOrganization
    :param primary_contact: Gets or sets the primary contact on the service
     request.
    :type primary_contact:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1ServiceRequestContact
    :param last_updated_by: Gets or sets the "Last Updated By" contact for
     changes to the service request.
    :type last_updated_by:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1ServiceRequestContact
    :param product_name: Gets or sets the name of the product that corresponds
     to the service request.
    :type product_name: str
    :param product_id: Gets or sets the ID of the product.
    :type product_id: str
    :param created_date: Gets or sets the date that the service request was
     created.
    :type created_date: datetime
    :param last_modified_date: Gets or sets the date that the service request
     was last modified.
    :type last_modified_date: datetime
    :param last_closed_date: Gets or sets the date that the service request
     was last closed.
    :type last_closed_date: datetime
    :param file_links: Gets or sets the collection of File Links that pertain
     to the service request.
    :type file_links:
     list[~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1FileInfo]
    :param new_note: Gets or sets a note that can be added to an existing
     service request.
    :type new_note:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1ServiceRequestNote
    :param notes: Gets or sets a collection of notes added to the service
     request.
    :type notes:
     list[~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1ServiceRequestNote]
    :param country_code: Gets or sets the country corresponding to the service
     request.
    :type country_code: str
    :ivar attributes: Gets the attributes.
    :vartype attributes:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1CommonResourceAttributes
    """

    _validation = {
        'attributes': {'readonly': True},
    }

    _attribute_map = {
        'title': {'key': 'title', 'type': 'str'},
        'description': {'key': 'description', 'type': 'str'},
        'severity': {'key': 'severity', 'type': 'str'},
        'support_topic_id': {'key': 'supportTopicId', 'type': 'str'},
        'support_topic_name': {'key': 'supportTopicName', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'status': {'key': 'status', 'type': 'str'},
        'organization': {'key': 'organization', 'type': 'MicrosoftPartnerSdkContractsV1ServiceRequestOrganization'},
        'primary_contact': {'key': 'primaryContact', 'type': 'MicrosoftPartnerSdkContractsV1ServiceRequestContact'},
        'last_updated_by': {'key': 'lastUpdatedBy', 'type': 'MicrosoftPartnerSdkContractsV1ServiceRequestContact'},
        'product_name': {'key': 'productName', 'type': 'str'},
        'product_id': {'key': 'productId', 'type': 'str'},
        'created_date': {'key': 'createdDate', 'type': 'iso-8601'},
        'last_modified_date': {'key': 'lastModifiedDate', 'type': 'iso-8601'},
        'last_closed_date': {'key': 'lastClosedDate', 'type': 'iso-8601'},
        'file_links': {'key': 'fileLinks', 'type': '[MicrosoftPartnerSdkContractsV1FileInfo]'},
        'new_note': {'key': 'newNote', 'type': 'MicrosoftPartnerSdkContractsV1ServiceRequestNote'},
        'notes': {'key': 'notes', 'type': '[MicrosoftPartnerSdkContractsV1ServiceRequestNote]'},
        'country_code': {'key': 'countryCode', 'type': 'str'},
        'attributes': {'key': 'attributes', 'type': 'MicrosoftPartnerSdkContractsV1CommonResourceAttributes'},
    }

    def __init__(self, title=None, description=None, severity=None, support_topic_id=None, support_topic_name=None, id=None, status=None, organization=None, primary_contact=None, last_updated_by=None, product_name=None, product_id=None, created_date=None, last_modified_date=None, last_closed_date=None, file_links=None, new_note=None, notes=None, country_code=None):
        super(MicrosoftPartnerSdkContractsV1ServiceRequest, self).__init__()
        self.title = title
        self.description = description
        self.severity = severity
        self.support_topic_id = support_topic_id
        self.support_topic_name = support_topic_name
        self.id = id
        self.status = status
        self.organization = organization
        self.primary_contact = primary_contact
        self.last_updated_by = last_updated_by
        self.product_name = product_name
        self.product_id = product_id
        self.created_date = created_date
        self.last_modified_date = last_modified_date
        self.last_closed_date = last_closed_date
        self.file_links = file_links
        self.new_note = new_note
        self.notes = notes
        self.country_code = country_code
        self.attributes = None
